#include "fibo.h"

FIBO_EXTERN
FIBO_TYPE fibonacci_iter(FIBO_TYPE n)
{
	FIBO_TYPE a = 0;
	FIBO_TYPE b = 1;
	FIBO_TYPE tmp;
	for (int i = 0; i < n; i++)
	{
		tmp = a;
		a = b;
		b = tmp + b;
	}

	return a;
}

#define MAT_SQUARE() {\
        tmpa = a*a+b*c;\
        tmpd = c*b+d*d;\
        b = b*a+b*d;\
        c = a*c+c*d;\
        a = tmpa;\
        d = tmpd;\
        }

#define MAT_SQUARE_Y() {\
        tmpa = a*ya+b*yc;\
        tmpd = c*yb+d*yd;\
        yb = yb*a+b*yd;\
        yc = ya*c+yc*d;\
        ya = tmpa;\
        yd = tmpd;\
        }

FIBO_EXTERN
FIBO_TYPE fibonacci_log(FIBO_TYPE n)
{
	FIBO_TYPE a = 1;
	FIBO_TYPE b = 1;
	FIBO_TYPE c = 1;
	FIBO_TYPE d = 0;

	FIBO_TYPE ya = 1;
	FIBO_TYPE yb = 0;
	FIBO_TYPE yc = 0;
	FIBO_TYPE yd = 1;

	FIBO_TYPE tmpa;
	FIBO_TYPE tmpd;

	if (n == 0)
		return 0;

	while (n > 1)
	{
		if (n & 1)
		{
			MAT_SQUARE_Y();
			MAT_SQUARE();
			n = (n - 1) / 2;
		} else
		{
			MAT_SQUARE();
			n /= 2;
		}
	}

	/*
	printf("end\n");
	printf("( %d %d )\n", a, b);
	printf("( %d %d )\n\n", c, d);

	printf("y( %d %d )\n", ya, yb);
	printf("y( %d %d )\n\n", yc, yd);
	*/
	return a * yb + b * yd;
}

FIBO_EXTERN
FIBO_TYPE_BIG *fibonacci_log2(FIBO_TYPE_BIG n)
{
	mpz_sub_ui(n, n, 1);

	FIBO_TYPE_BIG a;
	FIBO_TYPE_BIG b;
	FIBO_TYPE_BIG c;
	FIBO_TYPE_BIG ta;
	FIBO_TYPE_BIG tb;
	FIBO_TYPE_BIG tc;
	FIBO_TYPE_BIG A;
	FIBO_TYPE_BIG B;
	FIBO_TYPE_BIG C;
	FIBO_TYPE_BIG D;
	FIBO_TYPE_BIG T;

	mpz_inits(a, b, c, ta, tb, tc, A, B, C, D, T, NULL);
	mpz_set_ui(a, 1);
	mpz_set_ui(b, 1);
	mpz_set_ui(c, 0);
	mpz_set_ui(ta, 1);
	mpz_set_ui(tb, 0);
	mpz_set_ui(tc, 0);

	while (mpz_cmp_ui(n, 0) > 0)
	{
		if (mpz_tstbit(n, 0))
		{
			mpz_mul(T, b, tb);
			mpz_mul(A, b, ta);
			mpz_mul(B, c, tb);
			mpz_add(tb, A, B);
			mpz_mul(A, a, ta);
			mpz_add(ta, A, T);
			mpz_mul(A, c, tc);
			mpz_add(tc, T, A);
			mpz_sub_ui(n, n, 1);
		}
		mpz_mul(A, a, a);
		mpz_mul(B, b, b);
		mpz_mul(C, c, c);
		mpz_add(T, a, c);
		mpz_mul(D, b, T);
		mpz_add(a, A, B);
		mpz_set(b, D);
		mpz_add(c, B, C);
		mpz_cdiv_q_ui(n, n, 2);
	}

	FIBO_TYPE_BIG *export = malloc(sizeof(FIBO_TYPE_BIG));
	mpz_init_set(*export, ta);
	return export;
}