#include "fibo.h"

#include <time.h>

int main(void)
{
	FIBO_TYPE i = 1000000000;
	FIBO_TYPE_BIG input;
	mpz_init_set_ui(input, i);
	FIBO_TYPE r1, r2;
	FIBO_TYPE_BIG *r4;
	clock_t ta, tb, tc, td;

	ta = clock();
	r1 = fibonacci_iter(i);
	tb = clock();
	r2 = fibonacci_log(i);

	tc = clock();
	r4 = fibonacci_log2(input);
	td = clock();


	printf("clocks \t\t= %d %d %d %d\n", (unsigned int) ta, (unsigned int) tb, (unsigned int) tc,
	       (unsigned int) td);
	printf("CLOCKS_PER_SEC \t= %g\n", (double) CLOCKS_PER_SEC);
	printf("fibo_iter \t= %.3f ms (%d clocks)\n", (tb - ta) * 1.0 / CLOCKS_PER_SEC * 1000, (int) (tb - ta));
	printf("fibo_log \t= %.3f ms (%d clocks)\n", (tc - tb) * 1.0 / CLOCKS_PER_SEC * 1000, (int) (tc - tb));

	printf("fibo_log2 \t= %.3f ms (%d clocks)\n", (td - tc) * 1.0 / CLOCKS_PER_SEC * 1000, (int) (td - tc));
	printf("Resultats \t= %u %u\n", r1, r2);
	printf("FIBO BIG : ");
	//mpz_out_str(stdout, 10, *r4);
	printf("\n");

	return (int) r4;
}